/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2010 C.  - assia.ariouatr@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.controls.etatFrais.chorus;

import java.util.Hashtable;
import java.util.Stack;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;

/**
 * EtatsFrais/Invoice/AccountingSupplierParty/Party/AgentParty/PostalAddress/Country est obligatoire si PostalAddress est présent
 * @author Assia ARIOUAT
 */
public class M078 extends AbstractUnitControl {
    public static final String CTRL_ID = "CTL-M078" ;
    public static final transient String RESET_COUNTER_PATH = "EtatsFrais/Invoice/";
    public static final transient String INVOICEID_PATH = "EtatsFrais/Invoice/ID/";
    public static final transient String Country_PATH= "EtatsFrais/Invoice/AccountingSupplierParty/Party/AgentParty/PostalAddress/Country/";
    public static final transient String CHEMIN_PostalAddress = "EtatsFrais/Invoice/AccountingSupplierParty/Party/AgentParty/PostalAddress/";
    public static final transient String RETURN_ANOMALIES_PATH = RESET_COUNTER_PATH;

    private static final Logger logger = Logger.getLogger(M078.class);

    // pour stocker tous les paramètres d'execution des controles
    private Hashtable<String,Object> hParams;

    // pour stocker l'identifiant de l'invoice, on en a besoin pour générer l'anomalie
    private String invoiceId = null;
	private String ID_Invoice_Unique = "";
    private Boolean Country_exist = false;
    private Boolean PostalAddress_exist = false;
    private String PostalAddress_NodeId = "";
    private String PostalAddress = "";
    
    
    
    // pour récupérer le texte des balises
    private Stack<StringBuffer> chars = new Stack<StringBuffer>();

    // pour stocker les anomalies que l'on génère
    Vector<Anomalie> anomalies = null;

    public void endDocument() throws SAXException { }

    public void startElement(String uri, String localName, String qName, Attributes atts, String xpath) throws SAXException {
        if(xpath.equals(RESET_COUNTER_PATH)) {           
            anomalies = new Vector<Anomalie>();
            invoiceId = "";
            Country_exist =false;
            PostalAddress_exist=false;
            PostalAddress_NodeId = "";
            ID_Invoice_Unique = atts.getValue("ano:unique-id");
        } 
        if(xpath.equals(Country_PATH)) {
        	Country_exist= true;	
        }
        if(xpath.equals(CHEMIN_PostalAddress)) {
        PostalAddress_exist=true;
        PostalAddress_NodeId = atts.getValue("ano:node-id");
        }
        chars.push(new StringBuffer());
    }

    public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
    	
    		if(xpath.equals(INVOICEID_PATH)) {
    			invoiceId = chars.peek().toString();
    		} else if(xpath.equals(CHEMIN_PostalAddress)) {
    			PostalAddress = chars.peek().toString();
    		}
    		 else if(xpath.equals(RETURN_ANOMALIES_PATH) && PostalAddress_exist && !Country_exist) {       	
        	
        			String anoId = IdGenerator.nextId();
                    Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
                    xslParams.put("anoId", anoId);
                    xslParams.put("presentation","src");
                    String libelleLien = "Invoice "+invoiceId;
                    String path = "@ano:unique-id='" + ID_Invoice_Unique + "'";  // le XPath qui permettra de retrouver le
                    // on reconstitue le message
                    String message = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
                    message = message.replace("#INVOICE_ID#", invoiceId);
                    Anomalie ano = new Anomalie(anoId,
                            getDocumentModel().getControlById(CTRL_ID),
                            getDocumentModel().getDocumentId(),
                            "EtatFrais",
                            "invoice",
                            invoiceId,
                            localName,  // l'élément en anomalie est bien Invoice
                            libelleLien,
                            message,
                            getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                            getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                            path,
                            xslParams);
                    ano.addNode(new Node(PostalAddress_NodeId));
                    anomalies.add(ano);
        	
            chars.pop();
            return anomalies;
        }
        chars.pop();
        return null;
    }

    public void characters(char[] ch, int start, int length, String xpath) throws SAXException {
        // on met les caractères lus dans la pile
        chars.peek().append(ch, start, length);
    }

    public void ignorableWhitespace(char[] ch, int start, int length, String xpath) throws SAXException { }

    public void processingInstruction(String target, String data, String xpath) throws SAXException { }

    public void skippedEntity(String name, String xpath) throws SAXException { }

    public void setParameters(Hashtable<String, Object> params) {
        this.hParams=params;
    }

    public void setDocumentLocator(Locator locator) { }

    public void startDocument() throws SAXException { }

    public void startPrefixMapping(String prefix, String uri, String xpath) throws SAXException { }

    public void endPrefixMapping(String prefix, String xpath) throws SAXException { }
}
